#include <sta/rtos/signal.hpp>


namespace sta
{
	RtosSignal::RtosSignal(osSemaphoreId_t * semaphore)
		: semaphore_{semaphore}
	{}

	void RtosSignal::notify()
	{
		osSemaphoreRelease(*semaphore_);
	}

	bool RtosSignal::peek()
	{
		return (osSemaphoreGetCount(*semaphore_) != 0);
	}

	bool RtosSignal::test()
	{
		return (osSemaphoreAcquire(*semaphore_, 0) == osOK);
	}

	void RtosSignal::wait()
	{
		osSemaphoreAcquire(*semaphore_, osWaitForever);
	}
} // namespace sta
